function crr = C_R_R(c,a,NA,f,f_p,f_p_r,C_R,f_C_R)
% this function is used for generating the Raman gain coefficient which is
% dependent on both the pump channel frequency and the difference between
% pump and signal channels

global N
M = length(f_C_R);
for xx = 1:N
    for yy = 1:N
        AA = find(f_C_R<=f(xx,yy));
        if isempty(AA)
            crr(xx,yy) = C_R(1);
        elseif length(AA) == M
            crr(xx,yy) = C_R(M);
        else
            n1 = max(AA);
            n2 = n1+1;
            mm = (C_R(n2)-C_R(n1))/(f_C_R(n2)-f_C_R(n1));
            b = C_R(n2)-mm*f_C_R(n2);
            crr(xx,yy) = mm*f(xx,yy)+b;
            
        end
    end
end

% above: translate the measured Raman gain coefficient to each pair of
% signal-signal or signal-pump

% below: associated with pump and reference frequencies and also the
% effective area
crr = crr.*((f_p-f)./(f_p_r-f)).*((A_eff_2_D(f_p_r,c,NA,a)+ ...
    A_eff_2_D(f_p_r-f,c,NA,a))./(A_eff_2_D(f_p,c,NA,a)+...
    A_eff_2_D(f_p-f,c,NA,a)));

crr(isinf(crr) | isnan(crr)) = 0;
end