
 function  [Pout_dBm z]=SRS_effect_improved(c,a,NA,f_ref_raman,P_in_dBm_vector_in_z0,CCFV,f0,C_R,f_C_R,alpha_0_vec_freq_dep,deltaz,Ls_km)
 % here we use improved version of Raman Solver that
% gets more parameters as "NA" (numerical apperture)
% and "a" (fiber radious) and "f_ref_raman" to
% modify the C_R function from 1-D to 2-D
 
 % a_vec,NA_vec,f_ref_raman
 
 global  C  alpha N
 alpha=alpha_0_vec_freq_dep';
%  P_lin_W=10.^(-3+P_in_dBm_vector_in_z0/10);
 P_lin_W=P_in_dBm_vector_in_z0;
 N=length(P_in_dBm_vector_in_z0);
 P_col=P_lin_W';
 P=repmat(P_col,1,N);
 freq=f0+CCFV;
 F1=repmat(freq,N,1);
 F2=repmat(freq',1,N);
 C=(F1>=F2).*C_R_R(c,a,NA,F1-F2,F1,f_ref_raman,C_R,f_C_R)-(F2>F1).*(F2./F1).*C_R_R(c,a,NA,F2-F1,F2,f_ref_raman,C_R,f_C_R);
 Ls_m=Ls_km*1000;
 options = odeset('RelTol',1e-12);
 [z,Pout_lin_W] = ode45(@vdp1,[0:deltaz:Ls_m],P_col',options);
 Pout_lin_W(Pout_lin_W<=0)=1e-300;
 %(P.*C)*P_col-(alpha).*(P_col);
 %Pout_lin_W=
 Pout_dBm=Pout_lin_W;

 end
 
 function crr=C_R_R(c,a,NA,f,f_p,f_p_r,C_R,f_C_R)
 
 global N
 
 M=length(f_C_R);
 for xx=1:N
     for yy=1:N
       AA=(find(f_C_R<=f(xx,yy)));  
       if length(AA)==0
         crr(xx,yy)=C_R(1);  
       elseif length(AA)==M
          crr(xx,yy)=C_R(M);
       else
           n1=max(AA);
           n2=n1+1;
           mm=(C_R(n2)-C_R(n1))/(f_C_R(n2)-f_C_R(n1));
           b=C_R(n2)-mm*f_C_R(n2);
           crr(xx,yy)=mm*f(xx,yy)+b;
           
        end
     end
 end
 %A_eff_2_D(f_mat,c,NA,a);
 
 crr=crr.*((f_p-f)./(f_p_r-f)).*((A_eff_2_D(f_p_r,c,NA,a)+A_eff_2_D(f_p_r-f,c,NA,a))./(A_eff_2_D(f_p,c,NA,a)+A_eff_2_D(f_p-f,c,NA,a)));
 crr(isinf(crr) | isnan(crr))=0;
 end
 
 function dydz = vdp1(z,y)
     global C alpha N
y=y.*(y>0);
dydz = (repmat(y,1,N).*C)*y-(alpha).*(y); 
%[y(2); (1-y(1)^2)*y(2)-y(1)];
 end













%  function  [Pout_dBm z P_out_dBm_bw P_out_dBm_ASE]=SRS_effect(P_in_dBm_vector_in_z0,CCFV,f0,C_R,f_C_R,alpha_0_vec_freq_dep,deltaz,Ls_km,P_in_dBm_bwp_without_dep,alfa_bwp_without_dep,f_bwp_without_dep,BW_n_ch,Temp,P_in_dBm_Fwp,alfa_Fwp,f_Fwp)
%  global  C  alpha N N_bw P_bw dz C_bw PP_t C_t nuu_k deltanuk F_p
%  
%  if length(P_in_dBm_bwp_without_dep)>0
%     alpha=alfa_bwp_without_dep';
%     P_lin_W=10.^(-3+P_in_dBm_bwp_without_dep/10);
%     N=length(P_in_dBm_bwp_without_dep);
%     P_col=P_lin_W';
%     P=repmat(P_col,1,N);
%     freq=f0+f_bwp_without_dep;
%     F1=repmat(freq,N,1);
%     F2=repmat(freq',1,N);
%     C=(F1>F2).*C_R_R(F1-F2,C_R,f_C_R)-(F2>F1).*(F2./F1).*C_R_R(F2-F1,C_R,f_C_R);
%     Ls_m=Ls_km*1000;
%     options = odeset('RelTol',1e-10);
%     [z,Pout_lin_W] = ode45(@vdp1,[0:deltaz:Ls_m],P_col',options);
%     Pout_lin_W(Pout_lin_W<=0)=1e-30;
%     for nn=1:size(Pout_lin_W,1)
%         P_evol_bwp_lin_W(nn,:)=Pout_lin_W(size(Pout_lin_W,1)+1-nn,:);
%     end
%     P_out_dBm_bw=10*log10(1000*P_evol_bwp_lin_W);
%     N_bw=length(P_in_dBm_bwp_without_dep);
%     P_bw=P_evol_bwp_lin_W;
%     dz=deltaz;
%     %freq=f0+CCFV;
%     F1=repmat(f_bwp_without_dep,length([CCFV f_Fwp]),1);
%     F2=repmat([CCFV f_Fwp]',1,N_bw);
%     C_bw=(F1>F2).*C_R_R(F1-F2,C_R,f_C_R)-(F2>F1).*(F2./F1).*C_R_R(F2-F1,C_R,f_C_R);
% 
%  else
%      
%      P_out_dBm_bw=[];
%  end
%  
%  %P_in_dBm_Fwp,alfa_Fwp,f_Fwp
%  alpha=[alpha_0_vec_freq_dep alfa_Fwp]';
%  P_lin_W=10.^(-3+[P_in_dBm_vector_in_z0 P_in_dBm_Fwp]/10);
%  %N=length(P_in_dBm_vector_in_z0);
%  N=length(P_lin_W);
%  P_col=P_lin_W';
%  P=repmat(P_col,1,N);
%  freq=f0+[CCFV f_Fwp];
%  %freq3=f0+[CCFV f_Fwp]
%  F1=repmat(freq,N,1);
%  F2=repmat(freq',1,N);
%  C=(F1>F2).*C_R_R(F1-F2,C_R,f_C_R)-(F2>F1).*(F2./F1).*C_R_R(F2-F1,C_R,f_C_R);
%  Ls_m=Ls_km*1000;
%  options = odeset('RelTol',1e-12);
%  if length(P_in_dBm_bwp_without_dep)>0
%      [z,Pout_lin_W] = ode45(@vdp2,[0:deltaz:Ls_m],P_col',options);
%  else
%      [z,Pout_lin_W] = ode45(@vdp1,[0:deltaz:Ls_m],P_col',options);
%  end
%  Pout_lin_W(Pout_lin_W<=0)=1e-30;
%  %(P.*C)*P_col-(alpha).*(P_col);
%  %Pout_lin_W=
%  Pout_dBm=10*log10(1000*Pout_lin_W);
%  
%  %%%%%%%%%%%%%%%%%%%%%%%%
%  %%%%%%  ASE calculation
%  CCFV_2=[CCFV f_Fwp f_bwp_without_dep];
%  freq2=f0+CCFV_2;
%  PP_t=10.^(-3+0.1*[Pout_dBm P_out_dBm_bw]);
%  F1=repmat(freq2,length(freq),1);
%  F2=repmat(freq',1,length(freq2));
%  C_t=(F1>F2).*C_R_R(F1-F2,C_R,f_C_R)-(F2>F1).*(F2./F1).*C_R_R(F2-F1,C_R,f_C_R);
%  nuu_k=(f0+[CCFV f_Fwp])';
%  deltanuk=[BW_n_ch 1e6*ones(1,length(f_Fwp))]';
%  h=6.62607004e-34;
%  k_B=1.38064852e-23;
%  N_p=1./(exp((h/(k_B*Temp))*abs(F1-F2))-1);
%  N_p(find(F1==F2))=0;
%  F_p=(N_p+1).*(F1>F2)-N_p.*(F1<=F2);
%  [z,Pout_lin_ASE_W] = ode45(@vdp3,[0:deltaz:Ls_m],zeros(length(freq),1),options);
%  P_out_dBm_ASE=10*log10(1000*Pout_lin_ASE_W(:,1:length(CCFV)));
%  %%%%%%%%%%%%%%%%%%%%%%%%%
%  %%%%%%%%%%%%%%%%%%%%%%%%%%%
%  
%  
% 
%  end
%  
%  
%  function crr=C_R_R(f,C_R,f_C_R)
%  
% % global N
%  N1=size(f,1);
%  N2=size(f,2);
%  M=length(f_C_R);
%  for xx=1:N1
%      for yy=1:N2
%        AA=(find(f_C_R<=f(xx,yy)));  
%        if length(AA)==0
%          crr(xx,yy)=C_R(1);  
%        elseif length(AA)==M
%           crr(xx,yy)=C_R(M);
%        else
%            n1=max(AA);
%            n2=n1+1;
%            mm=(C_R(n2)-C_R(n1))/(f_C_R(n2)-f_C_R(n1));
%            b=C_R(n2)-mm*f_C_R(n2);
%            crr(xx,yy)=mm*f(xx,yy)+b;
%            
%         end
%      end
%  end
%  
%  end
%  
%  function dydz = vdp1(z,y)
%      global C alpha N
% y=y.*(y>0);
% dydz = (repmat(y,1,N).*C)*y-(alpha).*(y); 
% %[y(2); (1-y(1)^2)*y(2)-y(1)];
%  end
% 
%  function dydz = vdp2(z,y)
%      global C alpha N N_bw P_bw dz C_bw
%      n1=floor(z/dz)+1;
% y=y.*(y>0);
% dydz = (repmat(y,1,N).*C)*y-(alpha).*(y)+(repmat(y,1,N_bw).*C_bw)*(P_bw(n1,:))';
% %[y(2); (1-y(1)^2)*y(2)-y(1)];
%  end
%  
%   function dydz = vdp3(z,y)
%      global C alpha N N_bw P_bw dz C_bw PP_t C_t nuu_k deltanuk F_p
%      n1=floor(z/dz)+1;
%      P1=(PP_t(n1,:))';
%      h=6.62607004e-34;
% y=y.*(y>0);
% dydz = (repmat(y,1,N+N_bw).*C_t)*P1-(alpha).*(y)+(repmat(h*nuu_k.*deltanuk,1,N+N_bw).*(C_t.*F_p))*P1;
% %(repmat(y,1,N_bw).*C_bw)*(P_bw(n1,:))';
% %[y(2); (1-y(1)^2)*y(2)-y(1)];
%  end